import threading

class Job(threading.Thread):
    def __init__(self, seconds, execute, *args, **kwargs):
        threading.Thread.__init__(self)
        self.daemon = False
        self.event = threading.Event()
        self.seconds = seconds
        self.execute = execute
        self.args = args
        self.kwargs = kwargs
        self.finish = False
        
    def stop(self):
        self.finish = True
        self.event.set()
        self.join()

    def restart(self):
        self.event.set()

    def run(self):
        while not self.finish:
            while not self.event.wait(self.seconds):
                self.execute(*self.args, **self.kwargs)
            self.event.clear()