from PIL import Image

class Glyph:
    def __init__(self, size, blackpixels, redpixels):
        self.size = size
        self.blackpixels = blackpixels
        self.redpixels = redpixels

    def drawOn(self, blackimage, redimage, position):
        blackglyph = Image.frombuffer("1", self.size, self.blackpixels, "raw", "1", 0, 1)
        blackimage.paste(blackglyph, position)        
        redglyph = Image.frombuffer("1", self.size, self.redpixels, "raw", "1", 0, 1)
        redimage.paste(redglyph, position)

class GlyphRepository:
    weatherGlyphs = {
        "01d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\x7f\xff\xcf\xff\xfb\xff\xfc\xff\xfe\x3f\xff\xcf\xff\xf1\xff\xfc\xff\xff\x1f\xff\xcf\xff\xe3\xff\xfc\xff\xff\x8f\xff\xff\xff\xc7\xff\xfc\xff\xff\xc7\xff\xff\xff\x8f\xff\xfc\xff\xff\xe3\xff\xff\xff\x1f\xff\xfc\xff\xff\xf1\xfe\x01\xfe\x3f\xff\xfc\xff\xff\xf8\xf0\x00\x3c\x7f\xff\xfc\xff\xff\xfd\xe0\x78\x1e\xff\xff\xfc\xff\xff\xff\x83\xff\x07\xff\xff\xfc\xff\xff\xff\x0f\xff\xc3\xff\xff\xfc\xff\xff\xff\x1f\xff\xe3\xff\xff\xfc\xff\xff\xfe\x3f\xff\xf1\xff\xff\xfc\xff\xff\xfc\x7f\xff\xf8\xff\xff\xfc\xff\xff\xfc\x7f\xff\xf8\xff\xff\xfc\xff\xff\xfc\xff\xff\xfc\xff\xff\xfc\xff\xff\xf8\xff\xff\xfc\x7f\xff\xfc\xff\xff\xf8\xff\xff\xfc\x7f\xff\xfc\xff\xff\xf9\xff\xff\xfe\x7f\xff\xfc\xff\x00\x39\xff\xff\xfe\x70\x03\xfc\xff\x00\x39\xff\xff\xfe\x70\x03\xfc\xff\xff\xf9\xff\xff\xfe\x7f\xff\xfc\xff\xff\xf8\xff\xff\xfc\x7f\xff\xfc\xff\xff\xf8\xff\xff\xfc\x7f\xff\xfc\xff\xff\xfc\xff\xff\xfc\xff\xff\xfc\xff\xff\xfc\x7f\xff\xf8\xff\xff\xfc\xff\xff\xfc\x7f\xff\xf8\xff\xff\xfc\xff\xff\xfe\x3f\xff\xf1\xff\xff\xfc\xff\xff\xff\x1f\xff\xe3\xff\xff\xfc\xff\xff\xff\x0f\xff\xc3\xff\xff\xfc\xff\xff\xff\x83\xff\x07\xff\xff\xfc\xff\xff\xfd\xe0\x78\x1e\xff\xff\xfc\xff\xff\xf8\xf0\x00\x3c\x7f\xff\xfc\xff\xff\xf1\xfe\x01\xfe\x3f\xff\xfc\xff\xff\xe3\xff\xff\xff\x1f\xff\xfc\xff\xff\xc7\xff\xff\xff\x8f\xff\xfc\xff\xff\x8f\xff\xff\xff\xc7\xff\xfc\xff\xff\x1f\xff\xcf\xff\xe3\xff\xfc\xff\xfe\x3f\xff\xcf\xff\xf1\xff\xfc\xff\xff\x7f\xff\xcf\xff\xfb\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "01n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\x03\xff\xff\xff\xfc\xff\xff\xff\xf8\x03\xff\xff\xff\xfc\xff\xff\xff\xf0\x03\xff\xff\xff\xfc\xff\xff\xff\xc0\xe3\xff\xff\xff\xfc\xff\xff\xff\x87\xe7\xff\xff\xff\xfc\xff\xff\xff\x0f\xc7\xff\xff\xff\xfc\xff\xff\xfe\x1f\xc7\xff\xff\xff\xfc\xff\xff\xfc\x3f\xc7\xff\xff\xff\xfc\xff\xff\xfc\x7f\x8f\xff\xff\xff\xfc\xff\xff\xf8\xff\x8f\xff\xff\xff\xfc\xff\xff\xf8\xff\x8f\xff\xff\xff\xfc\xff\xff\xf1\xff\x8f\xff\xff\xff\xfc\xff\xff\xf1\xff\x8f\xff\xff\xff\xfc\xff\xff\xf1\xff\xc7\xff\xff\xff\xfc\xff\xff\xe3\xff\xc7\xff\xff\xff\xfc\xff\xff\xe3\xff\xc7\xff\xff\xff\xfc\xff\xff\xe3\xff\xe3\xff\xff\xff\xfc\xff\xff\xe3\xff\xe3\xff\xff\xff\xfc\xff\xff\xe3\xff\xf1\xff\xff\xff\xfc\xff\xff\xe3\xff\xf0\xff\xff\xff\xfc\xff\xff\xf1\xff\xf8\x7f\xff\xff\xfc\xff\xff\xf1\xff\xfc\x3f\xff\xff\xfc\xff\xff\xf1\xff\xfe\x1f\xff\xff\xfc\xff\xff\xf8\xff\xff\x07\xff\xff\xfc\xff\xff\xf8\xff\xff\x80\xff\xff\xfc\xff\xff\xfc\x7f\xff\xe0\x3f\xff\xfc\xff\xff\xfc\x7f\xff\xfc\x3f\xff\xfc\xff\xff\xfe\x3f\xff\xfc\x3f\xff\xfc\xff\xff\xff\x0f\xff\xf8\x7f\xff\xfc\xff\xff\xff\x87\xff\xe0\xff\xff\xfc\xff\xff\xff\xc1\xff\x81\xff\xff\xfc\xff\xff\xff\xe0\x00\x07\xff\xff\xfc\xff\xff\xff\xf8\x00\x1f\xff\xff\xfc\xff\xff\xff\xff\x00\x7f\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "02d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xfe\x7f\xff\xff\xff\xfc\xff\xff\xff\xc0\x03\xff\xff\xff\xfc\xff\xff\xff\x00\x00\xff\xff\xff\xfc\xff\xff\xfe\x07\xf0\x7f\xff\xff\xfc\xff\xff\xfc\x3f\xfc\x3f\xff\xff\xfc\xff\xff\xf8\x7f\xff\x1f\xff\xff\xfc\xff\xf8\x01\xff\xff\x8f\xff\xff\xfc\xff\xf0\x03\xff\xff\xc7\xff\xff\xfc\xff\xe1\xc3\xff\xff\xc7\xff\xff\xfc\xff\xc7\xff\xff\xff\xe3\xff\xff\xfc\xff\xc7\xff\xff\xff\xe3\xff\xff\xfc\xff\xc7\xff\xff\xff\xf3\xff\xff\xfc\xff\xcf\xff\xff\xff\xf1\xff\xff\xfc\xff\x87\xff\xff\xff\xf0\x7f\xff\xfc\xfe\x07\xff\xff\xff\xf0\x1f\xff\xfc\xfc\x0f\xff\xff\xff\xf8\x0f\xff\xfc\xf8\x7f\xff\xff\xff\xff\x83\xff\xfc\xf1\xff\xff\xff\xff\xff\xe3\xff\xfc\xe3\xff\xff\xff\xff\xff\xf1\xff\xfc\xe3\xff\xff\xff\xff\xff\xf9\xff\xfc\xe7\xff\xff\xff\xff\xff\xf8\xff\xfc\xc7\xff\xff\xff\xff\xff\xf8\xff\xfc\xc7\xff\xff\xff\xff\xff\xfc\xff\xfc\xc7\xff\xff\xff\xff\xff\xfc\xff\xfc\xc7\xff\xff\xff\xff\xff\xfc\xff\xfc\xc7\xff\xff\xff\xff\xff\xf8\xff\xfc\xe3\xff\xff\xff\xff\xff\xf8\xff\xfc\xe3\xff\xff\xff\xff\xff\xf1\xff\xfc\xf1\xff\xff\xff\xff\xff\xe1\xff\xfc\xf0\xff\xff\xff\xff\xff\xc3\xff\xfc\xf8\x00\x00\x00\x00\x00\x07\xff\xfc\xfc\x00\x00\x00\x00\x00\x1f\xff\xfc\xff\x00\x00\x00\x00\x00\x3f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xfc\xff\xff\xf9\xff\xfe\x7f\xff\xcf\xfc\xff\xff\xf8\xff\xfe\x7f\xff\x8f\xfc\xff\xff\xfc\x7f\xfe\x7f\xff\x1f\xfc\xff\xff\xfe\x3f\xff\xff\xfe\x3f\xfc\xff\xff\xff\x1f\xff\xff\xfc\x7f\xfc\xff\xff\xff\x8f\xf8\x1f\xf8\xff\xfc\xff\xff\xff\xc7\xc0\x03\xf1\xff\xfc\xff\xff\xff\xe7\x00\x00\xf3\xff\xfc\xff\xff\xff\xfe\x0f\xf0\x7f\xff\xfc\xff\xff\xff\xfc\x3f\xfc\x1f\xff\xfc\xff\xff\xff\xf8\x7f\xff\x1f\xff\xfc\xff\xff\xff\xf0\xff\xff\x8f\xff\xfc\xff\xff\xff\xf1\xff\xff\xc7\xff\xfc\xff\xff\xff\xe3\xff\xff\xc7\xff\xfc\xff\xff\xff\xe3\xff\xff\xe3\xff\xfc\xff\xff\xff\xe7\xff\xff\xe3\xff\xfc\xff\xff\xff\xc7\xff\xff\xe3\xff\xfc\xff\xff\xff\xc7\xff\xff\xf3\xff\xfc\xff\xf8\x01\xcf\xff\xff\xf3\x80\x0c\xff\xf8\x01\xff\xff\xff\xf3\x80\x0c\xff\xff\xff\xff\xff\xff\xf3\xff\xfc\xff\xff\xff\xff\xff\xff\xf3\xff\xfc\xff\xff\xff\xff\xff\xff\xe3\xff\xfc\xff\xff\xff\xff\xff\xff\xe3\xff\xfc\xff\xff\xff\xff\xff\xff\xe3\xff\xfc\xff\xff\xff\xff\xff\xff\xc7\xff\xfc\xff\xff\xff\xff\xff\xff\x87\xff\xfc\xff\xff\xff\xff\xff\xff\x0f\xff\xfc\xff\xff\xff\xff\xff\xfe\x1f\xff\xfc\xff\xff\xff\xff\xff\xfe\x3f\xff\xfc\xff\xff\xff\xff\xff\xff\x7f\xff\xfc\xff\xff\xff\xff\xff\xff\xf3\xff\xfc\xff\xff\xff\xff\xff\xff\xf1\xff\xfc\xff\xff\xff\xff\xff\xff\xf8\xff\xfc\xff\xff\xff\xff\xff\xff\xfc\x7f\xfc\xff\xff\xff\xff\xff\xff\xfe\x3f\xfc\xff\xff\xff\xff\xff\xff\xff\x1f\xfc\xff\xff\xff\xff\xff\xff\xff\x8f\xfc\xff\xff\xff\xff\xff\xff\xff\xcf\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "02n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xe3\xff\xfc\xff\xff\xff\xff\xff\xfe\x03\xff\xfc\xff\xff\xff\xff\xff\xf0\x03\xff\xfc\xff\xff\xff\xff\xff\xe0\x63\xff\xfc\xff\xff\xff\xff\xff\x83\xe3\xff\xfc\xff\xff\xff\xff\xff\x0f\xc7\xff\xfc\xff\xff\xff\xff\xfe\x1f\xc7\xff\xfc\xff\xff\xff\xff\xfe\x3f\xc7\xff\xfc\xff\xff\xff\xff\xfc\x7f\xcf\xff\xfc\xff\xff\xff\xff\xf8\xff\xcf\xff\xfc\xff\xff\xff\xff\xf8\xff\xcf\xff\xfc\xff\xff\xff\xff\xf9\xff\xcf\xff\xfc\xff\xff\xff\xff\xf1\xff\xcf\xff\xfc\xff\xff\xff\xff\xf1\xff\xcf\xff\xfc\xff\xff\xff\xff\xf3\xff\xc7\xff\xfc\xff\xff\xff\xff\xf3\xff\xc7\xff\xfc\xff\xff\xff\xff\xf3\xff\xc7\xff\xfc\xff\xff\xff\xff\xf3\xff\xe3\xff\xfc\xff\xff\xff\xff\xff\xff\xe3\xff\xfc\xff\xff\xff\xfc\x07\xff\xf1\xff\xfc\xff\xff\xff\xe0\x00\xff\xf8\xff\xfc\xff\xff\xff\x80\x00\x3f\xf8\x7f\xfc\xff\xff\xff\x07\xfc\x1f\xfc\x3f\xfc\xff\xff\xfe\x1f\xff\x0f\xfe\x0f\xfc\xff\xff\x0c\x3f\xff\x87\xff\x81\xfc\xff\xfc\x00\x7f\xff\xc3\xff\xc0\x3c\xff\xf8\x00\xff\xff\xe3\xff\xf0\x3c\xff\xf0\xf1\xff\xff\xf1\xff\xfc\x3c\xff\xf1\xff\xff\xff\xf1\xff\xf8\x7c\xff\xe3\xff\xff\xff\xf8\xff\xf0\xfc\xff\xe3\xff\xff\xff\xf8\xff\xc1\xfc\xff\xe3\xff\xff\xff\xf8\xff\x03\xfc\xff\xc3\xff\xff\xff\xfc\x1e\x0f\xfc\xff\x03\xff\xff\xff\xfc\x06\x3f\xfc\xfe\x07\xff\xff\xff\xff\x03\xff\xfc\xfc\x3f\xff\xff\xff\xff\xe1\xff\xfc\xf8\x7f\xff\xff\xff\xff\xf8\xff\xfc\xf8\xff\xff\xff\xff\xff\xf8\x7f\xfc\xf1\xff\xff\xff\xff\xff\xfc\x7f\xfc\xf1\xff\xff\xff\xff\xff\xfe\x7f\xfc\xf3\xff\xff\xff\xff\xff\xfe\x3f\xfc\xf3\xff\xff\xff\xff\xff\xfe\x3f\xfc\xf3\xff\xff\xff\xff\xff\xfe\x3f\xfc\xf3\xff\xff\xff\xff\xff\xfe\x3f\xfc\xf1\xff\xff\xff\xff\xff\xfc\x7f\xfc\xf1\xff\xff\xff\xff\xff\xfc\x7f\xfc\xf8\xff\xff\xff\xff\xff\xf8\xff\xfc\xf8\x7f\xff\xff\xff\xff\xf0\xff\xfc\xfc\x3f\xff\xff\xff\xff\xe1\xff\xfc\xfe\x00\x00\x00\x00\x00\x03\xff\xfc\xff\x00\x00\x00\x00\x00\x0f\xff\xfc\xff\xe0\x00\x00\x00\x00\x3f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "03d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\x80\x1f\xff\xff\xfc\xff\xff\xff\xfe\x00\x07\xff\xff\xfc\xff\xff\xff\xf8\x0f\x01\xff\xff\xfc\xff\xff\xff\xf0\x7f\xe0\xff\xff\xfc\xff\xff\xff\xe1\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x43\xff\xfc\x3f\xff\xfc\xff\xff\xc0\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc0\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x3f\xfc\xff\xe0\xff\xff\xff\xff\xfc\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe1\xff\xff\xff\xff\xfc\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\xff\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "03n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\x80\x1f\xff\xff\xfc\xff\xff\xff\xfe\x00\x07\xff\xff\xfc\xff\xff\xff\xf8\x0f\x01\xff\xff\xfc\xff\xff\xff\xf0\x7f\xe0\xff\xff\xfc\xff\xff\xff\xe1\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x43\xff\xfc\x3f\xff\xfc\xff\xff\xc0\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc0\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x3f\xfc\xff\xe0\xff\xff\xff\xff\xfc\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe1\xff\xff\xff\xff\xfc\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\xff\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "04d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\x80\x1f\xff\xff\xfc\xff\xff\xff\xfe\x00\x07\xff\xff\xfc\xff\xff\xff\xf8\x0f\x01\xff\xff\xfc\xff\xff\xff\xf0\x7f\xe0\xff\xff\xfc\xff\xff\xff\xe1\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x43\xff\xfc\x3f\xff\xfc\xff\xff\xc0\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc0\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x3f\xfc\xff\xe0\xff\xff\xff\xff\xfc\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe1\xff\xff\xff\xff\xfc\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\xff\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "04n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\x80\x1f\xff\xff\xfc\xff\xff\xff\xfe\x00\x07\xff\xff\xfc\xff\xff\xff\xf8\x0f\x01\xff\xff\xfc\xff\xff\xff\xf0\x7f\xe0\xff\xff\xfc\xff\xff\xff\xe1\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x43\xff\xfc\x3f\xff\xfc\xff\xff\xc0\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc0\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x3f\xfc\xff\xe0\xff\xff\xff\xff\xfc\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe1\xff\xff\xff\xff\xfc\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\xff\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "09d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xc0\x7f\xff\xff\xfc\xff\xff\xff\xfe\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf0\x7f\xc1\xff\xff\xfc\xff\xff\xff\xe1\xff\xf0\x7f\xff\xfc\xff\xff\xf0\xc3\xff\xfc\x7f\xff\xfc\xff\xff\xc0\x07\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc1\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x7f\xfc\xff\xe0\x7f\xff\xff\xff\xf8\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x9f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xe0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\x7f\xfc\xff\xff\x00\x00\x00\x00\x03\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xef\xf9\xfe\x7f\xbf\xff\xfc\xff\xff\xc7\xf1\xfc\x7f\x1f\xff\xfc\xff\xff\x87\xe1\xf8\x7e\x1f\xff\xfc\xff\xff\x0f\xc3\xf0\xfc\x3f\xff\xfc\xff\xfe\x1f\x87\xf1\xf8\x7f\xff\xfc\xff\xff\x3f\x0f\xfb\xf0\xff\xff\xfc\xff\xff\xfe\x1f\xff\xe1\xff\xff\xfc\xff\xff\xfc\x3f\x3f\xc3\xff\xff\xfc\xff\xff\xf8\x7e\x3f\x87\xff\xff\xfc\xff\xff\xf8\xfc\x3f\x8f\xff\xff\xfc\xff\xff\xfd\xf8\x7f\xdf\xff\xff\xfc\xff\xff\xff\xf8\xff\xff\xff\xff\xfc\xff\xff\xff\xf9\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "09n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xc0\x7f\xff\xff\xfc\xff\xff\xff\xfe\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf0\x7f\xc1\xff\xff\xfc\xff\xff\xff\xe1\xff\xf0\x7f\xff\xfc\xff\xff\xf0\xc3\xff\xfc\x7f\xff\xfc\xff\xff\xc0\x07\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xff\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfc\x3f\xff\xff\xff\xc1\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x7f\xfc\xff\xe0\x7f\xff\xff\xff\xf8\x1f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x9f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xe0\x00\x00\x00\x00\x00\x3f\xfc\xff\xf8\x00\x00\x00\x00\x00\x7f\xfc\xff\xff\x00\x00\x00\x00\x03\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xef\xf9\xfe\x7f\xbf\xff\xfc\xff\xff\xc7\xf1\xfc\x7f\x1f\xff\xfc\xff\xff\x87\xe1\xf8\x7e\x1f\xff\xfc\xff\xff\x0f\xc3\xf0\xfc\x3f\xff\xfc\xff\xfe\x1f\x87\xf1\xf8\x7f\xff\xfc\xff\xff\x3f\x0f\xfb\xf0\xff\xff\xfc\xff\xff\xfe\x1f\xff\xe1\xff\xff\xfc\xff\xff\xfc\x3f\x3f\xc3\xff\xff\xfc\xff\xff\xf8\x7e\x3f\x87\xff\xff\xfc\xff\xff\xf8\xfc\x3f\x8f\xff\xff\xfc\xff\xff\xfd\xf8\x7f\xdf\xff\xff\xfc\xff\xff\xff\xf8\xff\xff\xff\xff\xfc\xff\xff\xff\xf9\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "10d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xf8\x07\xff\xff\xff\xfc\xff\xff\xff\xc0\x01\xff\xff\xff\xfc\xff\xff\xff\x83\xf0\x7f\xff\xff\xfc\xff\xff\xfe\x1f\xfc\x3f\xff\xff\xfc\xff\xff\x8c\x3f\xff\x1f\xff\xff\xfc\xff\xfe\x00\x7f\xff\x8f\xff\xff\xfc\xff\xfc\x00\xff\xff\x8f\xff\xff\xfc\xff\xf8\xf9\xff\xff\xc7\xff\xff\xfc\xff\xf8\xff\xff\xff\xe7\xff\xff\xfc\xff\xf9\xff\xff\xff\xe7\xff\xff\xfc\xff\xf9\xff\xff\xff\xe3\xff\xff\xfc\xff\xf9\xff\xff\xff\xf1\xff\xff\xfc\xff\xc1\xff\xff\xff\xf0\x3f\xff\xfc\xff\x81\xff\xff\xff\xf8\x1f\xff\xfc\xff\x0f\xff\xff\xff\xff\x8f\xff\xfc\xfe\x3f\xff\xff\xff\xff\xc7\xff\xfc\xfe\x7f\xff\xff\xff\xff\xe3\xff\xfc\xfc\x7f\xff\xff\xff\xff\xe3\xff\xfc\xfc\xff\xff\xff\xff\xff\xf3\xff\xfc\xfc\xff\xff\xff\xff\xff\xf3\xff\xfc\xfc\xff\xff\xff\xff\xff\xf3\xff\xfc\xfc\xff\xff\xff\xff\xff\xf3\xff\xfc\xfc\x7f\xff\xff\xff\xff\xf3\xff\xfc\xfc\x7f\xff\xff\xff\xff\xe3\xff\xfc\xfe\x3f\xff\xff\xff\xff\xc7\xff\xfc\xfe\x1f\xff\xff\xff\xff\x8f\xff\xfc\xff\x0f\xff\xff\xff\xfe\x0f\xff\xfc\xff\x80\x00\x00\x00\x00\x3f\xff\xfc\xff\xe0\x00\x00\x00\x00\x7f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\x3f\x1f\x8f\xe7\xff\xff\xfc\xff\xfe\x3e\x1f\x0f\xc7\xff\xff\xfc\xff\xfc\x7c\x3f\x1f\x8f\xff\xff\xfc\xff\xfc\xf8\x7f\x3f\x1f\xff\xff\xfc\xff\xff\xf0\xff\xfe\x3f\xff\xff\xfc\xff\xff\xe1\xff\xfc\x7f\xff\xff\xfc\xff\xff\xc3\xf3\xfc\xff\xff\xff\xfc\xff\xff\xc7\xe1\xff\xff\xff\xff\xfc\xff\xff\xcf\xc3\xff\xff\xff\xff\xfc\xff\xff\xff\x87\xff\xff\xff\xff\xfc\xff\xff\xff\x8f\xff\xff\xff\xff\xfc\xff\xff\xff\xdf\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xcf\xff\xff\xff\xfc\xff\xff\xff\xff\xc7\xff\xe3\xff\xfc\xff\xff\xff\xff\xe7\xff\xe7\xff\xfc\xff\xff\xff\xff\xe7\xff\xc7\xff\xfc\xff\xff\xff\xff\xe3\xff\x8f\xff\xfc\xff\xff\xff\xff\xe3\xff\x1f\xff\xfc\xff\xff\xff\xff\xf7\xff\x1f\xff\xfc\xff\xff\xff\xff\xff\xfe\x3f\xff\xfc\xff\xff\xe3\xff\xf8\x0f\x7f\xff\xfc\xff\xff\xe0\xff\xc0\x03\xff\xff\xfc\xff\xff\xf0\x7f\x03\xc0\xff\xff\xfc\xff\xff\xfc\x1e\x1f\xf8\x7f\xff\xfc\xff\xff\xff\x1c\x3f\xfc\x3f\xff\xfc\xff\xff\xff\x9c\x7f\xff\x1f\xff\xfc\xff\xff\xff\xf8\xff\xff\x1f\xff\xfc\xff\xff\xff\xf1\xff\xff\x8f\xf8\xfc\xff\xff\xff\xf1\xff\xff\xcf\x80\xfc\xff\xff\xff\xf3\xff\xff\xce\x01\xfc\xff\xff\xff\xe3\xff\xff\xc6\x3f\xfc\xff\xff\xff\xe3\xff\xff\xc7\xff\xfc\xff\xff\xff\xef\xff\xff\xc7\xff\xfc\xff\xff\xff\xff\xff\xff\xc7\xff\xfc\xff\xff\xff\xff\xff\xff\xc7\xff\xfc\xff\xff\xff\xff\xff\xff\xcf\xff\xfc\xff\xff\xff\xff\xff\xff\xcf\xff\xfc\xff\xff\xff\xff\xff\xff\x8f\xff\xfc\xff\xff\xff\xff\xff\xff\x9f\xff\xfc\xff\xff\xff\xff\xff\xff\x1f\xff\xfc\xff\xff\xff\xff\xff\xfe\x3f\xff\xfc\xff\xff\xff\xff\xff\xfc\x71\xff\xfc\xff\xff\xff\xff\xff\xfe\xf0\xff\xfc\xff\xff\xff\xff\xff\xff\xfc\x3f\xfc\xff\xff\xff\xff\xff\xff\xfe\x1f\xfc\xff\xff\xff\xff\xff\xff\xff\x87\xfc\xff\xff\xff\xff\xff\xff\xff\xc7\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "10n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xfe\x07\xff\xfc\xff\xff\xff\xff\xff\xf0\x07\xff\xfc\xff\xff\xff\xff\xff\xe0\x07\xff\xfc\xff\xff\xff\xff\xff\x83\xcf\xff\xfc\xff\xff\xff\xff\xff\x0f\x8f\xff\xfc\xff\xff\xff\xff\xfe\x1f\x9f\xff\xfc\xff\xff\xff\xff\xfc\x7f\x9f\xff\xfc\xff\xff\xff\xff\xfc\x7f\x1f\xff\xfc\xff\xff\xff\xff\xf8\xff\x1f\xff\xfc\xff\xff\xff\xff\xf1\xff\x3f\xff\xfc\xff\xff\xff\xff\xf1\xff\x3f\xff\xfc\xff\xff\xff\xff\xf3\xff\x1f\xff\xfc\xff\xff\xff\xff\xe3\xff\x1f\xff\xfc\xff\xff\xff\xff\xe3\xff\x9f\xff\xfc\xff\xff\xff\xff\xe3\xff\x9f\xff\xfc\xff\xff\xff\xff\xe7\xff\x8f\xff\xfc\xff\xff\xff\xff\xff\xff\xcf\xff\xfc\xff\xff\xff\xff\xff\xff\xc7\xff\xfc\xff\xff\xff\xfc\x0f\xff\xe3\xff\xfc\xff\xff\xff\xe0\x01\xff\xf1\xff\xfc\xff\xff\xff\x80\xc0\x7f\xf8\xff\xfc\xff\xff\xff\x0f\xfc\x3f\xfc\x3f\xfc\xff\xff\xfe\x1f\xfe\x1f\xfe\x0f\xfc\xff\xff\x00\x7f\xff\x8f\xff\x81\xfc\xff\xfe\x00\xff\xff\xcf\xff\xe0\xfc\xff\xfc\x78\xff\xff\xc7\xff\xf1\xfc\xff\xf8\xff\xff\xff\xe7\xff\xe3\xfc\xff\xf8\xff\xff\xff\xe3\xff\x87\xfc\xff\xf9\xff\xff\xff\xf3\xfe\x0f\xfc\xff\xf9\xff\xff\xff\xf3\xf8\x1f\xfc\xff\xe0\xff\xff\xff\xf0\x78\x7f\xfc\xff\xc1\xff\xff\xff\xf0\x1f\xff\xfc\xff\x87\xff\xff\xff\xff\x0f\xff\xfc\xff\x1f\xff\xff\xff\xff\xc7\xff\xfc\xfe\x3f\xff\xff\xff\xff\xe3\xff\xfc\xfe\x7f\xff\xff\xff\xff\xf3\xff\xfc\xfc\x7f\xff\xff\xff\xff\xf3\xff\xfc\xfc\x7f\xff\xff\xff\xff\xf1\xff\xfc\xfc\xff\xff\xff\xff\xff\xf1\xff\xfc\xfc\x7f\xff\xff\xff\xff\xf1\xff\xfc\xfc\x7f\xff\xff\xff\xff\xf1\xff\xfc\xfe\x7f\xff\xff\xff\xff\xf3\xff\xfc\xfe\x3f\xff\xff\xff\xff\xe3\xff\xfc\xff\x1f\xff\xff\xff\xff\xc7\xff\xfc\xff\x0f\xff\xff\xff\xff\x0f\xff\xfc\xff\x80\x00\x00\x00\x00\x1f\xff\xfc\xff\xe0\x00\x00\x00\x00\x3f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\x3f\x9f\xcf\xe7\xff\xff\xfc\xff\xfe\x3f\x1f\x8f\xc7\xff\xff\xfc\xff\xfc\x3e\x1f\x0f\x87\xff\xff\xfc\xff\xfc\x7c\x3f\x1f\x0f\xff\xff\xfc\xff\xfe\xf8\x7f\xbe\x1f\xff\xff\xfc\xff\xff\xf0\xff\xfc\x3f\xff\xff\xfc\xff\xff\xe1\xfb\xfc\x7f\xff\xff\xfc\xff\xff\xc3\xf1\xfc\xff\xff\xff\xfc\xff\xff\xc7\xe3\xff\xff\xff\xff\xfc\xff\xff\xff\xc7\xff\xff\xff\xff\xfc\xff\xff\xff\x8f\xff\xff\xff\xff\xfc\xff\xff\xff\xdf\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "11d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xc0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf0\x3f\xc1\xff\xff\xfc\xff\xff\xff\xe1\xff\xf0\xff\xff\xfc\xff\xff\xf0\xc3\xff\xfc\x7f\xff\xfc\xff\xff\xc0\x07\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfe\x3f\xff\xff\xff\xc1\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x7f\xfc\xff\xe0\x7f\xff\xff\xff\xf0\x1f\xfc\xff\xc3\xff\xff\xff\xff\xfe\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x9f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xe0\x0f\xff\xff\xff\xc0\x3f\xfc\xff\xf8\x0f\xff\xff\xff\xc0\x7f\xfc\xff\xfe\x1f\xff\xff\xff\xc3\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\x7f\xff\xfc\xff\xff\xff\xff\xff\xfe\x3f\xff\xfc\xff\xff\xff\xff\xff\xfc\x3f\xff\xfc\xff\xff\xff\xff\xff\xf8\x7f\xff\xfc\xff\xff\x1f\xff\xff\xf0\xff\xff\xfc\xff\xfe\x1f\xff\xff\xe1\xff\xff\xfc\xff\xfe\x3f\xff\xff\xc3\xff\xff\xfc\xff\xfe\x7f\xfe\x7f\x87\xff\xff\xfc\xff\xff\xff\xfc\x7f\x0f\xff\xff\xfc\xff\xff\xff\xf8\x7f\x1f\xff\xff\xfc\xff\xff\xff\xf0\xff\xff\xff\xff\xfc\xff\xff\xff\xf1\xff\xff\xff\xff\xfc\xff\xff\xff\xf3\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xf8\xff\xff\xfc\xff\xff\xff\xff\xff\xf0\xff\xff\xfc\xff\xff\xff\xff\xff\xe1\xff\xff\xfc\xff\xff\xff\xff\xff\xc3\xff\xff\xfc\xff\xff\xff\xff\xff\x87\xff\xff\xfc\xff\xff\xff\xfc\x7f\x0f\xff\xff\xfc\xff\xff\xff\xf8\x7e\x1f\xff\xff\xfc\xff\xff\xff\xf0\xfc\x3f\xff\xff\xfc\xff\xff\xff\xe1\xf8\x03\xff\xff\xfc\xff\xff\xff\xc3\xf8\x03\xff\xff\xfc\xff\xff\xff\x87\xfc\x07\xff\xff\xfc\xff\xff\xff\x0f\xff\x0f\xff\xff\xfc\xff\xff\xfe\x1f\xfe\x1f\xff\xff\xfc\xff\xff\xfc\x01\xfc\x3f\xff\xff\xfc\xff\xff\xfc\x01\xf8\x7f\xff\xff\xfc\xff\xff\xfe\x01\xf0\xff\xff\xff\xfc\xff\xff\xff\xc3\xe1\xff\xff\xff\xfc\xff\xff\xff\x87\xe3\xff\xff\xff\xfc\xff\xff\xff\x0f\xe7\xff\xff\xff\xfc\xff\xff\xfe\x1f\xff\xff\xff\xff\xfc\xff\xff\xfc\x3f\xff\xff\xff\xff\xfc\xff\xff\xf8\x7f\xff\xff\xff\xff\xfc\xff\xff\xf0\xff\xff\xff\xff\xff\xfc\xff\xff\xf1\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "11n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xc0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf0\x3f\xc1\xff\xff\xfc\xff\xff\xff\xe1\xff\xf0\xff\xff\xfc\xff\xff\xf0\xc3\xff\xfc\x7f\xff\xfc\xff\xff\xc0\x07\xff\xfe\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x1f\xff\xfc\xff\xff\x0f\x9f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xff\x3f\xff\xff\xff\xc7\xff\xfc\xff\xfe\x3f\xff\xff\xff\xc1\xff\xfc\xff\xf0\x3f\xff\xff\xff\xc0\x7f\xfc\xff\xe0\x7f\xff\xff\xff\xf0\x1f\xfc\xff\xc3\xff\xff\xff\xff\xfe\x0f\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x9f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xe0\x0f\xff\xff\xff\xc0\x3f\xfc\xff\xf8\x0f\xff\xff\xff\xc0\x7f\xfc\xff\xfe\x1f\xff\xff\xff\xc3\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\x7f\xff\xfc\xff\xff\xff\xff\xff\xfe\x3f\xff\xfc\xff\xff\xff\xff\xff\xfc\x3f\xff\xfc\xff\xff\xff\xff\xff\xf8\x7f\xff\xfc\xff\xff\x1f\xff\xff\xf0\xff\xff\xfc\xff\xfe\x1f\xff\xff\xe1\xff\xff\xfc\xff\xfe\x3f\xff\xff\xc3\xff\xff\xfc\xff\xfe\x7f\xfe\x7f\x87\xff\xff\xfc\xff\xff\xff\xfc\x7f\x0f\xff\xff\xfc\xff\xff\xff\xf8\x7f\x1f\xff\xff\xfc\xff\xff\xff\xf0\xff\xff\xff\xff\xfc\xff\xff\xff\xf1\xff\xff\xff\xff\xfc\xff\xff\xff\xf3\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xf8\xff\xff\xfc\xff\xff\xff\xff\xff\xf0\xff\xff\xfc\xff\xff\xff\xff\xff\xe1\xff\xff\xfc\xff\xff\xff\xff\xff\xc3\xff\xff\xfc\xff\xff\xff\xff\xff\x87\xff\xff\xfc\xff\xff\xff\xfc\x7f\x0f\xff\xff\xfc\xff\xff\xff\xf8\x7e\x1f\xff\xff\xfc\xff\xff\xff\xf0\xfc\x3f\xff\xff\xfc\xff\xff\xff\xe1\xf8\x03\xff\xff\xfc\xff\xff\xff\xc3\xf8\x03\xff\xff\xfc\xff\xff\xff\x87\xfc\x07\xff\xff\xfc\xff\xff\xff\x0f\xff\x0f\xff\xff\xfc\xff\xff\xfe\x1f\xfe\x1f\xff\xff\xfc\xff\xff\xfc\x01\xfc\x3f\xff\xff\xfc\xff\xff\xfc\x01\xf8\x7f\xff\xff\xfc\xff\xff\xfe\x01\xf0\xff\xff\xff\xfc\xff\xff\xff\xc3\xe1\xff\xff\xff\xfc\xff\xff\xff\x87\xe3\xff\xff\xff\xfc\xff\xff\xff\x0f\xe7\xff\xff\xff\xfc\xff\xff\xfe\x1f\xff\xff\xff\xff\xfc\xff\xff\xfc\x3f\xff\xff\xff\xff\xfc\xff\xff\xf8\x7f\xff\xff\xff\xff\xfc\xff\xff\xf0\xff\xff\xff\xff\xff\xfc\xff\xff\xf1\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "13d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xe0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf8\x1f\x81\xff\xff\xfc\xff\xff\xff\xe0\xff\xf0\xff\xff\xfc\xff\xff\xff\xc3\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x07\xff\xfc\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x87\x1f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x9f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xfe\x1f\xff\xff\xff\xc3\xff\xfc\xff\xf8\x1f\xff\xff\xff\xc0\x7f\xfc\xff\xf0\x1f\xff\xff\xff\xe0\x3f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xfe\x0f\xfc\xff\xe0\x00\x00\x00\x00\x00\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x7f\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xfb\xff\xff\xfc\xff\xff\xff\xff\xff\xf1\xff\xff\xfc\xff\xff\xff\xbf\xff\xf1\xff\xff\xfc\xff\xff\xff\x1f\xff\x11\x1f\xff\xfc\xff\xff\xff\x1f\xff\x00\x1f\xff\xfc\xff\xff\xf3\x19\xff\x80\x3f\xff\xfc\xff\xff\xf1\x11\xff\xc0\x7f\xff\xfc\xff\xff\xf0\x01\xff\x80\x3f\xff\xfc\xff\xff\xf8\x03\xff\x00\x1f\xff\xfc\xff\xff\xfc\x07\xff\x11\x1f\xff\xfc\xff\xff\x80\x00\x3f\xf1\xff\xff\xfc\xff\xff\x80\x00\x3f\xf1\xff\xff\xfc\xff\xff\xfc\x07\xff\xfb\xff\xff\xfc\xff\xff\xf8\x03\xff\xff\xff\xff\xfc\xff\xff\xf0\x01\xff\xff\xff\xff\xfc\xff\xff\xf1\x11\xff\xff\xff\xff\xfc\xff\xff\xf3\x19\xff\xff\xff\xff\xfc\xff\xff\xff\x1f\xff\xff\xff\xff\xfc\xff\xff\xff\x1f\xff\xff\xff\xff\xfc\xff\xff\xff\xbf\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "13n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xe0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x0f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf8\x1f\x81\xff\xff\xfc\xff\xff\xff\xe0\xff\xf0\xff\xff\xfc\xff\xff\xff\xc3\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x07\xff\xfc\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x87\x1f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x9f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xfe\x1f\xff\xff\xff\xc3\xff\xfc\xff\xf8\x1f\xff\xff\xff\xc0\x7f\xfc\xff\xf0\x1f\xff\xff\xff\xe0\x3f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xfe\x0f\xfc\xff\xe0\x00\x00\x00\x00\x00\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x7f\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xfb\xff\xff\xfc\xff\xff\xff\xff\xff\xf1\xff\xff\xfc\xff\xff\xff\xbf\xff\xf1\xff\xff\xfc\xff\xff\xff\x1f\xff\x11\x1f\xff\xfc\xff\xff\xff\x1f\xff\x00\x1f\xff\xfc\xff\xff\xf3\x19\xff\x80\x3f\xff\xfc\xff\xff\xf1\x11\xff\xc0\x7f\xff\xfc\xff\xff\xf0\x01\xff\x80\x3f\xff\xfc\xff\xff\xf8\x03\xff\x00\x1f\xff\xfc\xff\xff\xfc\x07\xff\x11\x1f\xff\xfc\xff\xff\x80\x00\x3f\xf1\xff\xff\xfc\xff\xff\x80\x00\x3f\xf1\xff\xff\xfc\xff\xff\xfc\x07\xff\xfb\xff\xff\xfc\xff\xff\xf8\x03\xff\xff\xff\xff\xfc\xff\xff\xf0\x01\xff\xff\xff\xff\xfc\xff\xff\xf1\x11\xff\xff\xff\xff\xfc\xff\xff\xf3\x19\xff\xff\xff\xff\xfc\xff\xff\xff\x1f\xff\xff\xff\xff\xfc\xff\xff\xff\x1f\xff\xff\xff\xff\xfc\xff\xff\xff\xbf\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "50d" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xe0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x1f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf8\x1f\x81\xff\xff\xfc\xff\xff\xff\xe0\xff\xf0\xff\xff\xfc\xff\xff\xff\xc3\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x07\xff\xfc\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x87\x1f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x9f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xfe\x3f\xff\xff\xff\xc3\xff\xfc\xff\xf8\x1f\xff\xff\xff\xc0\x7f\xfc\xff\xf0\x1f\xff\xff\xff\xe0\x3f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe0\x00\x00\x00\x00\x00\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x7f\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\x80\x03\x00\x00\x07\xff\xfc\xff\xff\x80\x03\x00\x00\x07\xff\xfc\xff\xff\xc0\x07\x80\x00\x0f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xf0\x00\x0e\x00\x3f\xff\xfc\xff\xff\xf0\x00\x0e\x00\x3f\xff\xfc\xff\xff\xf8\x00\x1f\x00\x7f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc"),
        "50n" : Glyph((70, 70), b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xe0\x7f\xff\xff\xfc\xff\xff\xff\xff\x00\x1f\xff\xff\xfc\xff\xff\xff\xfc\x00\x03\xff\xff\xfc\xff\xff\xff\xf8\x1f\x81\xff\xff\xfc\xff\xff\xff\xe0\xff\xf0\xff\xff\xfc\xff\xff\xff\xc3\xff\xf8\x7f\xff\xfc\xff\xff\xe0\x07\xff\xfc\x3f\xff\xfc\xff\xff\x80\x0f\xff\xfe\x3f\xff\xfc\xff\xff\x87\x1f\xff\xff\x1f\xff\xfc\xff\xff\x1f\xff\xff\xff\x9f\xff\xfc\xff\xff\x1f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\x8f\xff\xfc\xff\xff\x3f\xff\xff\xff\xcf\xff\xfc\xff\xfe\x3f\xff\xff\xff\xc3\xff\xfc\xff\xf8\x1f\xff\xff\xff\xc0\x7f\xfc\xff\xf0\x1f\xff\xff\xff\xe0\x3f\xfc\xff\xc1\xff\xff\xff\xff\xfe\x1f\xfc\xff\xc7\xff\xff\xff\xff\xff\x0f\xfc\xff\x8f\xff\xff\xff\xff\xff\x87\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xe3\xfc\xff\x1f\xff\xff\xff\xff\xff\xc7\xfc\xff\x8f\xff\xff\xff\xff\xff\xc7\xfc\xff\x87\xff\xff\xff\xff\xff\x8f\xfc\xff\xc3\xff\xff\xff\xff\xff\x0f\xfc\xff\xe0\x00\x00\x00\x00\x00\x1f\xfc\xff\xf0\x00\x00\x00\x00\x00\x7f\xfc\xff\xfc\x00\x00\x00\x00\x01\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\x80\x03\x00\x00\x07\xff\xfc\xff\xff\x80\x03\x00\x00\x07\xff\xfc\xff\xff\xc0\x07\x80\x00\x0f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xf0\x00\x0e\x00\x3f\xff\xfc\xff\xff\xf0\x00\x0e\x00\x3f\xff\xfc\xff\xff\xf8\x00\x1f\x00\x7f\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc", b"\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff\xfc")
    }

    
    weatherGlyphsSmall = {
        "01d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\x9f\xe7\xf9\xff\xff\x8f\xff\xf1\xff\xff\xc7\xff\xe3\xff\xff\xe3\x00\xc7\xff\xff\xf6\x00\x6f\xff\xff\xfc\x7e\x3f\xff\xff\xf9\xff\x9f\xff\xff\xf1\xff\x8f\xff\xff\xf3\xff\xcf\xff\xff\xf3\xff\xcf\xff\xf0\x33\xff\xcc\x0f\xf0\x33\xff\xcc\x0f\xff\xf3\xff\xcf\xff\xff\xf3\xff\xcf\xff\xff\xf1\xff\x9f\xff\xff\xf9\xff\x9f\xff\xff\xfc\x7e\x3f\xff\xff\xf6\x00\x6f\xff\xff\xe3\x01\xc7\xff\xff\xc7\xff\xe3\xff\xff\x8f\xff\xf1\xff\xff\x9f\xe7\xf9\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "01n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xc3\xff\xff\xff\xff\x03\xff\xff\xff\xfc\x33\xff\xff\xff\xfc\xf7\xff\xff\xff\xf9\xe7\xff\xff\xff\xf3\xe7\xff\xff\xff\xf3\xe7\xff\xff\xff\xe7\xe7\xff\xff\xff\xe7\xe7\xff\xff\xff\xe7\xf3\xff\xff\xff\xe7\xf3\xff\xff\xff\xe7\xf9\xff\xff\xff\xe7\xf8\xff\xff\xff\xf3\xfc\x3f\xff\xff\xf3\xff\x0f\xff\xff\xf9\xff\xc7\xff\xff\xf8\xff\xcf\xff\xff\xfc\x3f\x1f\xff\xff\xff\x00\x3f\xff\xff\xff\xc1\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "02d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x8f\xff\xff\xff\xfc\x01\xff\xff\xff\xf8\xf0\xff\xff\xff\x33\xfc\x7f\xff\xfe\x07\xfe\x3f\xff\xfc\xef\xff\x3f\xff\xfd\xff\xff\xbf\xff\xf9\xff\xff\x9f\xff\xf1\xff\xff\x87\xff\xe3\xff\xff\xe3\xff\xcf\xff\xff\xf9\xff\x9f\xff\xff\xfc\xff\x9f\xff\xff\xfc\xff\x9f\xff\xff\xfe\xff\x9f\xff\xff\xfc\xff\x9f\xff\xff\xfc\xff\xcf\xff\xff\xf9\xff\xe0\x00\x00\x03\xff\xf0\x00\x00\x07\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xfc\xff\xff\xff\xf7\xfc\xff\xbf\xff\xf3\xfc\xff\x3f\xff\xf9\xff\xfe\x7f\xff\xfc\xf8\x7c\xff\xff\xfe\x60\x19\xff\xff\xff\x87\x87\xff\xff\xff\x1f\xe3\xff\xff\xff\x3f\xf3\xff\xff\xfe\x7f\xf9\xff\xff\xfe\x7f\xf9\xff\xfe\x06\xff\xf9\x01\xfe\x07\xff\xf9\x01\xff\xff\xff\xf9\xff\xff\xff\xff\xf9\xff\xff\xff\xff\xf9\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xe3\xff\xff\xff\xff\xf5\xff\xff\xff\xff\xfc\xff\xff\xff\xff\xfe\x7f\xff\xff\xff\xff\x3f\xff\xff\xff\xff\x9f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "02n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xf1\xff\xff\xff\xff\x81\xff\xff\xff\xff\x19\xff\xff\xff\xfe\x79\xff\xff\xff\xfc\xf3\xff\xff\xff\xf9\xf3\xff\xff\xff\xf9\xf3\xff\xff\xff\xf3\xf3\xff\xff\xff\xf3\xf3\xff\xff\xff\xf3\xf9\xff\xff\xff\xff\xf9\xff\xff\xff\x03\xfc\xff\xff\xfc\x00\xfc\x7f\xff\xf8\xfc\x7e\x1f\xff\x03\xff\x3f\x87\xfe\x03\xff\x9f\xe3\xfe\x7f\xff\x9f\xe7\xfc\xff\xff\xcf\x8f\xfc\xff\xff\xc7\x1f\xf0\xff\xff\xc1\xff\xe3\xff\xff\xf8\xff\xe7\xff\xff\xfc\xff\xcf\xff\xff\xfe\x7f\xcf\xff\xff\xfe\x7f\xcf\xff\xff\xfe\x7f\xcf\xff\xff\xfe\x7f\xcf\xff\xff\xfc\xff\xe3\xff\xff\xf8\xff\xf0\x00\x00\x01\xff\xfc\x00\x00\x07\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "03d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\xc0\x3f\xff\xff\xff\x0e\x1f\xff\xff\xe2\x3f\x8f\xff\xff\xc0\x7f\xe7\xff\xff\x8c\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf0\xff\xfc\x3f\xff\xf8\x3f\xf8\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x1f\xfc\x7f\xff\xfe\x3f\xfe\x00\x00\x00\x7f\xff\x80\x00\x01\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "03n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\xc0\x3f\xff\xff\xff\x0e\x1f\xff\xff\xe2\x3f\x8f\xff\xff\xc0\x7f\xe7\xff\xff\x8c\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf0\xff\xfc\x3f\xff\xf8\x3f\xf8\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x1f\xfc\x7f\xff\xfe\x3f\xfe\x00\x00\x00\x7f\xff\x80\x00\x01\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "04d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\xc0\x3f\xff\xff\xff\x0e\x1f\xff\xff\xe2\x3f\x8f\xff\xff\xc0\x7f\xe7\xff\xff\x8c\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf0\xff\xfc\x3f\xff\xf8\x3f\xf8\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x1f\xfc\x7f\xff\xfe\x3f\xfe\x00\x00\x00\x7f\xff\x80\x00\x01\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "04n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\xc0\x3f\xff\xff\xff\x0e\x1f\xff\xff\xe2\x3f\x8f\xff\xff\xc0\x7f\xe7\xff\xff\x8c\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf0\xff\xfc\x3f\xff\xf8\x3f\xf8\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x1f\xfc\x7f\xff\xfe\x3f\xfe\x00\x00\x00\x7f\xff\x80\x00\x01\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "09d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x0f\xff\xff\xe0\x7f\xcf\xff\xff\xc0\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xfb\xff\xff\xff\xdf\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x00\x00\x00\x3f\xfe\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xef\xfd\xf7\xff\xff\xcf\x39\xe7\xff\xff\x9e\x7b\xcf\xff\xff\xfc\xff\x9f\xff\xff\xf9\xef\x3f\xff\xff\xf3\xce\x7f\xff\xff\xff\x9f\xff\xff\xff\xff\xbf\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "09n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x0f\xff\xff\xe0\x7f\xcf\xff\xff\xc0\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xfb\xff\xff\xff\xdf\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x00\x00\x00\x3f\xfe\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xef\xfd\xf7\xff\xff\xcf\x39\xe7\xff\xff\x9e\x7b\xcf\xff\xff\xfc\xff\x9f\xff\xff\xf9\xef\x3f\xff\xff\xf3\xce\x7f\xff\xff\xff\x9f\xff\xff\xff\xff\xbf\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "10d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x07\xff\xff\xff\xfc\x01\xff\xff\xff\x88\xfc\xff\xff\xff\x03\xfe\x7f\xff\xff\x33\xff\x3f\xff\xfe\x7f\xff\x3f\xff\xfe\x7f\xff\x9f\xff\xfc\x7f\xff\x87\xff\xf1\xff\xff\xe3\xff\xf3\xff\xff\xf9\xff\xe7\xff\xff\xf8\xff\xe7\xff\xff\xfc\xff\xe7\xff\xff\xfc\xff\xe7\xff\xff\xf9\xff\xf3\xff\xff\xf1\xff\xf8\x00\x00\x03\xff\xfc\x00\x00\x0f\xff\xff\xff\xff\xff\xff\xff\xbd\xe7\x3f\xff\xff\x19\xc6\x3f\xff\xfe\x31\xcc\x7f\xff\xff\x63\x78\xff\xff\xff\xc6\x39\xff\xff\xff\xcc\x7f\xff\xff\xff\xfc\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xe7\xfd\xff\xff\xff\xe3\xf9\xff\xff\xff\xf3\xf1\xff\xff\xff\xf3\xf3\xff\xff\xe7\xff\xf7\xff\xff\xe3\xf0\x3f\xff\xff\xf1\xc0\x0f\xff\xff\xf9\x8f\xc7\xff\xff\xff\x3f\xe7\x8f\xff\xff\x3f\xf2\x0f\xff\xff\x3f\xf2\x3f\xff\xff\xff\xf3\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xe7\xff\xff\xff\xff\xfc\x7f\xff\xff\xff\xfe\x3f\xff\xff\xff\xff\x1f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "10n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe3\xff\xff\xff\xff\x03\xff\xff\xff\xfe\x33\xff\xff\xff\xfc\xf7\xff\xff\xff\xf9\xf7\xff\xff\xff\xf9\xe7\xff\xff\xff\xf3\xe7\xff\xff\xff\xf3\xf7\xff\xff\xff\xf3\xf3\xff\xff\xff\xf7\xf3\xff\xff\xff\xff\xf9\xff\xff\xfe\x01\xf8\xff\xff\xfc\x00\xfc\x7f\xff\x81\xfc\x7f\x0f\xff\x03\xfe\x3f\xc7\xff\x3f\xff\x3f\x8f\xfe\x7f\xff\x9e\x1f\xfe\x7f\xff\x8e\x7f\xf8\x7f\xff\xc3\xff\xf1\xff\xff\xf3\xff\xe7\xff\xff\xf9\xff\xe7\xff\xff\xf9\xff\xe7\xff\xff\xf9\xff\xe7\xff\xff\xf9\xff\xf3\xff\xff\xf9\xff\xf1\xff\xff\xf3\xff\xf8\x00\x00\x07\xff\xfc\x00\x00\x0f\xff\xff\xff\xff\xff\xff\xff\x38\xc7\x3f\xff\xfe\x31\x8e\x3f\xff\xfe\x63\xdc\x7f\xff\xff\xc7\x7c\xff\xff\xff\xce\x3f\xff\xff\xff\xfc\x7f\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "11d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x1f\xff\xff\xe1\x7f\xcf\xff\xff\xc0\x7f\xe7\xff\xff\x9c\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf1\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x1f\xff\xf8\x3f\xfe\x0f\xff\xf0\xff\xff\xff\xff\xff\xff\xff\xff\xff\xef\xff\xff\xff\xff\xc7\xff\xff\x9f\xff\x8f\xff\xff\x1f\xff\x1f\xff\xff\x3f\xce\x3f\xff\xff\xff\x8e\x7f\xff\xff\xff\x1f\xff\xff\xff\xff\x3f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x9f\xff\xff\xff\xff\x1f\xff\xff\xff\xfe\x3f\xff\xff\xff\x9c\x7f\xff\xff\xff\x18\x3f\xff\xff\xfe\x38\x3f\xff\xff\xfc\x7c\x7f\xff\xff\xf8\x38\xff\xff\xff\xf8\x31\xff\xff\xff\xfc\x73\xff\xff\xff\xf8\xff\xff\xff\xff\xf1\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "11n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x1f\xff\xff\xe1\x7f\xcf\xff\xff\xc0\x7f\xe7\xff\xff\x9c\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x1f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf1\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x1f\xff\xf8\x3f\xfe\x0f\xff\xf0\xff\xff\xff\xff\xff\xff\xff\xff\xff\xef\xff\xff\xff\xff\xc7\xff\xff\x9f\xff\x8f\xff\xff\x1f\xff\x1f\xff\xff\x3f\xce\x3f\xff\xff\xff\x8e\x7f\xff\xff\xff\x1f\xff\xff\xff\xff\x3f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x9f\xff\xff\xff\xff\x1f\xff\xff\xff\xfe\x3f\xff\xff\xff\x9c\x7f\xff\xff\xff\x18\x3f\xff\xff\xfe\x38\x3f\xff\xff\xfc\x7c\x7f\xff\xff\xf8\x38\xff\xff\xff\xf8\x31\xff\xff\xff\xfc\x73\xff\xff\xff\xf8\xff\xff\xff\xff\xf1\xff\xff\xff\xff\xf3\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "13d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x0f\xff\xff\xe0\x7f\xcf\xff\xff\xc0\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xfb\xff\xff\xff\xdf\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x00\x00\x00\x7f\xff\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x9f\xff\xff\xfd\xfc\x93\xff\xff\xfd\xfe\x07\xff\xff\xe5\x3f\x0f\xff\xff\xf0\x7e\x07\xff\xff\xc0\x1c\x93\xff\xff\xc0\x1f\x9f\xff\xff\xf0\x7f\xff\xff\xff\xe5\x3f\xff\xff\xff\xfd\xff\xff\xff\xff\xfd\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "13n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x3f\xff\xff\xff\x1f\x0f\xff\xff\xe0\x7f\xcf\xff\xff\xc0\xff\xe7\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x9f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xfb\xff\xff\xff\xdf\xf9\xff\xff\xff\x9f\xf8\xff\xff\xff\x3f\xfc\x00\x00\x00\x7f\xff\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x9f\xff\xff\xfd\xfc\x93\xff\xff\xfd\xfe\x07\xff\xff\xe5\x3f\x0f\xff\xff\xf0\x7e\x07\xff\xff\xc0\x1c\x93\xff\xff\xc0\x1f\x9f\xff\xff\xf0\x7f\xff\xff\xff\xe5\x3f\xff\xff\xff\xfd\xff\xff\xff\xff\xfd\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "50d" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x1f\xff\xff\xfe\x1f\x8f\xff\xff\xe0\x7f\xc7\xff\xff\xc0\xff\xe7\xff\xff\x8f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf8\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf8\xff\xff\xfe\x3f\xfc\x00\x00\x00\x7f\xff\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x80\x40\x01\xff\xff\xc0\xe0\x03\xff\xff\xff\xff\xff\xff\xff\xe0\x06\x07\xff\xff\xf0\x0f\x0f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"),
        "50n" : Glyph((40, 40), b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xe0\xff\xff\xff\xff\x80\x1f\xff\xff\xfe\x1f\x8f\xff\xff\xe0\x7f\xc7\xff\xff\xc0\xff\xe7\xff\xff\x8f\xff\xf3\xff\xff\x9f\xff\xf3\xff\xff\x1f\xff\xf1\xff\xfe\x1f\xff\xf8\x7f\xfc\x7f\xff\xfe\x3f\xf8\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf3\xff\xff\xff\xcf\xf3\xff\xff\xff\xcf\xf9\xff\xff\xff\x9f\xf9\xff\xff\xff\x9f\xf8\xff\xff\xfe\x3f\xfc\x00\x00\x00\x7f\xff\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x80\x40\x01\xff\xff\xc0\xe0\x03\xff\xff\xff\xff\xff\xff\xff\xe0\x06\x07\xff\xff\xf0\x0f\x0f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", b"\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff")
    }
